#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Nov 18 18:27:51 2020

@author: artaxo
"""



#Importing libraries
import netCDF4 as nc4
import numpy as np
import csv
import pandas as pd
#%%%
inputFolder = '/home/out'
anos = (2010,2011,2012,2013,2014,2015,2016,2017,2018)
dias = ('01','10','20','28')
meses =  ('01','02','03','04','05','06','07','08','09','10','11','12')
parametros = ('PBLH','SWDOWN','T2','Q2','RAINC','RAINNC','V10','U10','V','U')
# year = 2015
# month = 5
# day=1
# varName = 'PBLH'
for varName in parametros:
    for year in anos:
        for month in meses:
            for day in dias:
                
                    # Reading WRF file number 1
                file1 = '/chap/d02/'+str(year)+'/wrfout_d02_'+str(year)+'-'+str(month)+'-'+str(day)+'_00:00:00'
                f1 = nc4.Dataset(inputFolder+ file1,'r')
                #var = f1.variables
                #print(var)
                #desc= f1.dimensions
                #print(desc)
                #md = f1.data_model
                #d1 = nc4.Dataset(f1)
                data1 = f1[varName][:]
                dim1 = f1[varName].dimensions
                lon1 = f1['XLONG'][:]
                lat1 = f1['XLAT'][:]
                
                time_var = f1.variables['XTIME']
                units = f1.variables['XTIME'].units
                dates = (nc4.num2date(time_var[:], units=units))
                dates = dates.tolist()
                timeArray = np.ma.compressed(dates)
                # timeArray = ', '.join([(x) for x in dates])
                timeArray = timeArray.astype("datetime64[ns]")
                
                
                #%%
                # Converting time to string 
                # timeArray = [str(s, encoding='UTF-8') for s in time]
                
                # Reading WRF file number 2
                file2 = '/flop/d02/'+str(year)+'/wrfout_d02_'+str(year)+'-'+str(month)+'-'+str(day)+'_00:00:00'
                f2 = nc4.Dataset(inputFolder+ file2,'r')
                data2 = f2[varName][:]
                #dim2 = f1[varName].dimensions
                lon2 = f2['XLONG'][:]
                lat2 = f2['XLAT'][:]
                #time2=f1['Times'][:]
                
                #Selecting conditions for merging
                lon1U = lon1[1,1,:]
                lon2U = lon2[1,1,:]
                lat1U = lat1[1,:,1]
                lat2U = lat2[1,:,1]
                
                deltaX = abs(np.min(lon1U) - np.max(lon2U))
                deltaCelX =  abs(lon1U[1] - lon1U[0])
                numX = round(deltaX/deltaCelX)
                lonN = np.linspace(np.min(lon1U),np.max(lon2U), num=numX)
                
                deltaY = abs(np.min(lat1U) - np.max(lat2U))
                #deltaCelY =  aNo docbs(lat1U[1] - lat1U[0])
                numY = round(deltaY/deltaCelX)
                latN = np.linspace(np.min([np.min(lat1U), np.min(lat2U)]),
                                           np.max([np.max(lat2U),np.max(lat1U)]), num=numY)
                
                
                xv, yv = np.meshgrid(lonN, latN)
                
                matF = np.zeros((f1['Times'].shape[0],xv.shape[0], xv.shape[1]))
                #for tt in range(0,matF.shape[0]):
                    #print('Time: ' + str(tt) +' of '+str(matF.shape[0]))
                for ii in range(0,matF.shape[1]):
                    print('Row: ' + str(ii) + ' of ' + str(matF.shape[1]))
                    for jj in range(0,matF.shape[2]):            
                        #print('collumn: ' + str(jj))
                        if xv[ii,jj] < -51.07548:
                            a = ((xv[ii,jj]-lon1[1,:,:])**2 + (yv[ii,jj]-lat1[1,:,:])**2)**(1/2)
                            idx1 = np.where(a==np.min(a))
                            matF[:,ii,jj]= data1[:,idx1[0][0],idx1[1][0]]
                        else:
                            a = ((xv[ii,jj]-lon2[1,:,:])**2 + (yv[ii,jj]-lat2[1,:,:])**2)**(1/2)
                            idx1 = np.where(a==np.min(a))
                            matF[:,ii,jj]= data2[:,idx1[0][0],idx1[1][0]]
                  
                #%%
                # Creating a dataset
                f3 = nc4.Dataset('/home/artaxo' + '/wrfout_'+varName+'_'+str(year)+'_'+str(month)+'_'+str(day)+'.nc','w', 
                                 format='NETCDF3_CLASSIC') #'w' stands for write
                #Add global attributes
                f3.description = 'Merged and regrided WRF files. Author: Leonardo Hoinaski'
                
                # create dimensions, variables and attributes:
                f3.createDimension('lon',matF.shape[2])
                f3.createDimension('lat',matF.shape[1])
                f3.createDimension('time',matF.shape[0])
                
                lon = f3.createVariable('lon','f4',('lon'))
                lon.units = 'degrees'
                lon.standard_name = 'longitude'
                lon[:] = lonN
                
                lat = f3.createVariable('lat','f4',('lat'))
                lat.units = 'degrees'
                lat.standard_name = 'latitude'
                lat[:] = latN
                
                time = f3.createVariable('time','f8',('time'))
                time.units = units
                
                time.standard_name = 'time'
                time[:] = time_var[:]
                #%%
                # Addind data to netCDF file
                var1  = f3.createVariable(varName, 'f4', ('time','lat','lon'))
                var1[:,:,:] = matF
                
                # Closing netCDF files    
                f1.close() 
                f2.close()
                f3.close()
